Index: Client.cpp
===================================================================
--- Client.cpp	(Revision 988)
+++ Client.cpp	(Arbeitskopie)
@@ -554,6 +554,27 @@
 
 	if (sCommand.CaseCmp("HELP") == 0) {
 		HelpUser();
+	} else if (sCommand.CaseCmp("KEEPBUFFER") == 0) {
+		bool enabled = sLine.Token(1).CaseCmp("TRUE") || sLine.Token(1).CaseCmp("ENABLE");
+		CString sChan = sLine.Token(2, true);
+		CChan* pChan = m_pUser->FindChan(sChan);
+
+		if (sChan.empty()) {
+			PutStatus("Usage: KeepBuffer <true/false> <#chan>");
+			return;
+		}
+
+		if (!pChan) {
+			PutStatus("You are not on [" + sChan + "]");
+			return;
+		}
+
+		pChan->SetKeepBuffer(enabled);
+
+		if (enabled)
+			PutStatus("Enabled KeepBuffer on [" + sChan + "]");
+		else
+			PutStatus("Disabled KeepBuffer on [" + sChan + "]");
 	} else if (sCommand.CaseCmp("LISTNICKS") == 0) {
 		CString sChan = sLine.Token(1);
 
@@ -1365,6 +1386,7 @@
 		Table.AddRow(); Table.SetCell("Command", "ListClients");Table.SetCell("Arguments", "");					Table.SetCell("Description", "List all clients connected to your znc user");
 	}
 
+	Table.AddRow(); Table.SetCell("Command", "KeepBuffer"); Table.SetCell("Arguments", "<true/false> <#chan>"); Table.SetCell("Description", "w00t wanted it :P");
 	Table.AddRow(); Table.SetCell("Command", "ListServers");Table.SetCell("Arguments", "");						Table.SetCell("Description", "List all servers");
 	Table.AddRow(); Table.SetCell("Command", "AddServer");	Table.SetCell("Arguments", "<host> [[+]port] [pass]");	Table.SetCell("Description", "Add a server to the list");
 	Table.AddRow(); Table.SetCell("Command", "RemServer");	Table.SetCell("Arguments", "<host>");				Table.SetCell("Description", "Remove a server from the list");
